
MFBYTESTREAM_IS_READABLE  equ   000000001
MFBYTESTREAM_IS_WRITABLE  equ   000000002
MFBYTESTREAM_IS_SEEKABLE  equ   000000004
MFBYTESTREAM_IS_REMOTE    equ   000000008



MFASYNC_CALLBACK_QUEUE_STANDARD equ 000000001
MFASYNC_CALLBACK_QUEUE_RT equ 000000002
MFASYNC_CALLBACK_QUEUE_IO  equ  000000003
MFASYNC_CALLBACK_QUEUE_TIMER  equ 000000004
MFASYNC_CALLBACK_QUEUE_MULTITHREADED  equ  000000005
MFASYNC_CALLBACK_QUEUE_LONG_FUNCTION  equ 000000007



.data                           

 vtbIMFByteStream            dd offset IUnknown_QueryInterface                                                                         
                             dd offset IUnknown_AddRef
                             dd offset IUnknown_Release
                       
                             dd offset IMFByteStream_GetCapabilities
                             dd offset IMFByteStream_GetLength
                             dd offset IMFByteStream_SetLength
                             dd offset IMFByteStream_GetCurrentPosition  
                             dd offset IMFByteStream_SetCurrentPosition                              
                             dd offset IMFByteStream_IsEndOfStream                                     
                             dd offset IMFByteStream_Read                                 
                             dd offset IMFByteStream_BeginRead                            
                             dd offset IMFByteStream_EndRead                             
                             dd offset IMFByteStream_Write                         
                             dd offset IMFByteStream_BeginWrite                            
                             dd offset IMFByteStream_EndWrite                             
                             dd offset IMFByteStream_Seek                                
                             dd offset IMFByteStream_Flush                                             
                             dd offset IMFByteStream_Close                 
                    
 IID_IMFByteStream GUID <0ad4c1b00h,04bf7h,0422fh,<091h,075h,075h,066h,093h,0d9h,013h,00dh>>
                
             

 objIMFByteStream OBJECT_DATA  <0, IMFByteStream_INUM, offset pIMFByteStream, offset IMFByteStream_Constructor, offset IMFByteStream_Destructor, 0, IMFByteStream_SIZE, 0, 0, 0, 0, 0 >     

 IMFByteStream_INUM     equ 2
 IMFByteStream_SIZE     equ (sizeof OBJECT_ENTRY * IMFByteStream_INUM) + sizeof IMFByteStream_PRIVATE_DATA + sizeof OBJECT_DATA
 pIMFByteStream         OBJECT_ENTRY <offset vtbIMFByteStream, 0, offset IID_IUnknown>                   
                        OBJECT_ENTRY <offset vtbIMFByteStream, 0, offset IID_IMFByteStream> 




.code

;#############################################

IMFByteStream_Constructor  proc uses edi esi ebx this_:dword
 
         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase    
         invoke  CoTaskMemAlloc, sizeof  IMFByteStream_PRIVATE_DATA 
         mov     (OBJECT_DATA ptr [ebx]).pPrivDat, eax  
         invoke  memset, (OBJECT_DATA ptr [ebx]).pPrivDat, 0, sizeof  IMFByteStream_PRIVATE_DATA    
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat                  
         ret

IMFByteStream_Constructor  endp

;#############################################

IMFByteStream_Destructor  proc uses edi esi ebx this_:dword 

         mov      ebx, this_
         mov      ebx, (OBJECT_ENTRY ptr [ebx]).pBase 
         mov      ebx, (OBJECT_DATA ptr [ebx]).pPrivDat                   
         coinvoke (IMFByteStream_PRIVATE_DATA ptr [ebx]).m_IMFAsyncResult, IUnknown, Release
         invoke   CoTaskMemFree, ebx             
         ret

IMFByteStream_Destructor  endp

;#############################################

IMFByteStream_GetCapabilities  proc uses edi esi ebx this_:dword, pdwCapabilities:dword

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat

         mov    edx, pdwCapabilities
         mov    ecx, MFBYTESTREAM_IS_READABLE or MFBYTESTREAM_IS_WRITABLE  or MFBYTESTREAM_IS_SEEKABLE or MFBYTESTREAM_IS_REMOTE
         mov    [edx], ecx
         xor     eax, eax
         ret

IMFByteStream_GetCapabilities  endp

;#############################################

IMFByteStream_GetLength  proc uses edi esi ebx this_:dword, pqwLengthL:dword, pqwLengthH:dword

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat

;mov ecx, 2
;int 3
         xor eax, eax
         ret

IMFByteStream_GetLength  endp

;#############################################

IMFByteStream_SetLength  proc uses edi esi ebx this_:dword, qwLengthL:dword, qwLengthH:dword

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat
;mov ecx, 3
;int 3
         xor eax, eax
         ret

IMFByteStream_SetLength  endp

;#############################################

IMFByteStream_GetCurrentPosition  proc uses edi esi ebx this_:dword, pqwPosition:dword

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat
                  
         mov     edx, pqwPosition            
         mov     eax, (IMFByteStream_PRIVATE_DATA ptr [ebx]).m_FilPointr               
         mov     [edx], dword ptr 0                  
         mov     [edx+4], eax
;mov ecx, 4

         xor eax, eax
         ret

IMFByteStream_GetCurrentPosition  endp

;#############################################

IMFByteStream_SetCurrentPosition  proc uses edi esi ebx this_:dword, qwPositionL:dword, qwPositionH:dword

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat
         
         
;mov ecx, 5
;int 3
         xor eax, eax
         ret

IMFByteStream_SetCurrentPosition  endp

;#############################################

IMFByteStream_IsEndOfStream  proc uses edi esi ebx this_:dword, pfEndOfStream:dword

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat

;mov ecx, 6
;int 3
         xor eax, eax
         ret

IMFByteStream_IsEndOfStream  endp

;#############################################

IMFByteStream_Read  proc uses edi esi ebx this_:dword, pb:dword, cb:dword, pcbRead:dword


         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat

;mov ecx, 7
;int 3
         xor eax, eax
         ret

IMFByteStream_Read  endp

;#############################################

IMFByteStream_BeginRead  proc uses edi esi ebx this_:dword, pb:dword, cb:dword, pCallback:dword, punkState:dword

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat

;mov ecx, 8
;int 3
         xor eax, eax
         ret

IMFByteStream_BeginRead  endp

;#############################################

IMFByteStream_EndRead  proc uses edi esi ebx this_:dword, pResult:dword, pcbRead:dword

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat

;mov ecx, 9
;int 3 
         xor eax, eax
         ret

IMFByteStream_EndRead  endp

;#############################################

IMFByteStream_Write  proc uses edi esi ebx this_:dword, pb:dword, cb:dword, pcbWritten:dword

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat

;mov ecx, 10
;int 3
         xor eax, eax
         ret

IMFByteStream_Write  endp

;#############################################

IMFByteStream_BeginWrite  proc uses edi esi ebx this_:dword, pb:dword, cb:dword, pCallback:dword, punkState:dword

         LOCAL  pdwFlags : dword
         LOCAL  pdwQueue : dword
         LOCAL  pobj     : dword
      
         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat
         
         mov     eax, cb
         mov     (IMFByteStream_PRIVATE_DATA ptr [ebx]).m_WriteCont, eax
         add     (IMFByteStream_PRIVATE_DATA ptr [ebx]).m_FilPointr, eax
         invoke WriteFileData, addr sResFil, pb, cb
         .if pCallback != 0
            mov      pdwFlags, 0
            mov      pdwQueue, 0
            coinvoke pCallback, IMFAsyncCallback, GetParameters, addr pdwFlags, addr pdwQueue
            mov      ecx, pdwFlags
            mov      edx, pdwQueue            

            .if dword ptr (IMFByteStream_PRIVATE_DATA ptr [ebx]).m_IMFAsyncResult == 0
               push     offset objIMFAsyncResult
               call     AllocObject
               mov      pobj, eax
               coinvoke pobj, IUnknown, AddRef
               mov      eax, pobj
               mov      (IMFByteStream_PRIVATE_DATA ptr [ebx]).m_IMFAsyncResult, eax
            .else
               mov      eax, (IMFByteStream_PRIVATE_DATA ptr [ebx]).m_IMFAsyncResult
               mov      pobj, eax
            .endif
            coinvoke pCallback, IMFAsyncCallback, Invoke, pobj                        
         .endif
         xor    eax, eax
         ret

IMFByteStream_BeginWrite  endp

;#############################################

IMFByteStream_EndWrite  proc uses edi esi ebx this_:dword, pResult:dword, pcbWritten:dword

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat

         mov      ecx, pcbWritten
         mov      eax, (IMFByteStream_PRIVATE_DATA ptr [ebx]).m_WriteCont
         mov      [ecx], eax

         mov      eax, pResult
         mov      edx, (IMFByteStream_PRIVATE_DATA ptr [ebx]).m_IMFAsyncResult

;mov   ecx, 12
         xor eax, eax
         ret

IMFByteStream_EndWrite  endp

;#############################################

IMFByteStream_Seek  proc uses edi esi ebx this_:dword, SeekOrigin:dword, llSeekOffsetL:dword, llSeekOffsetH:dword, dwSeekFlags:dword, pqwCurrentPositionL:dword, pqwCurrentPositionH:dword

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat

;mov ecx, 13
;int 3
         xor eax, eax
         ret

IMFByteStream_Seek  endp

;#############################################

IMFByteStream_Flush proc uses edi esi ebx this_:dword               

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat

;mov ecx, 14
;int 3
         xor eax, eax
         ret

IMFByteStream_Flush  endp

;#############################################

IMFByteStream_Close proc uses edi esi ebx this_:dword


         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase              
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat

;mov ecx, 15
;int 3
         xor eax, eax
         ret

IMFByteStream_Close  endp

;#############################################

WriteFileData proc  uses edi esi ebx lpFeileName:dword, pBuffe:dword, bfsize:dword
                                     
      LOCAL  retVal   : dword
      LOCAL  hzObject : dword
                                
      mov     retVal, -1
      invoke  CreateFileA, lpFeileName, 40000000h, 3, 0, 4, 80h, 0
      .if eax != -1                                  
         mov     hzObject, eax  
         invoke  SetFilePointer, hzObject, 0, 0, FILE_END
         invoke  WriteFile, hzObject, pBuffe, bfsize, addr retVal, 0
         invoke  CloseHandle, hzObject         
      .endif                                                       
      mov  eax, retVal
      ret

WriteFileData endp

;####################################################